import java.io.*; 
import java.lang.Integer;

public class AcessoDireto {

	public static void main(String[] args)
	{
		try {
			int i;
			Bucket bucket = new Bucket();
			
			FileInputStream stream = new FileInputStream("../EDIIA32.txt");
			InputStreamReader streamReader = new InputStreamReader(stream);
			BufferedReader reader = new BufferedReader(streamReader);
			RandomAccessFile raf = new RandomAccessFile
			                       (new File("../AcessoDireto.dsk"), "rw");
				
			String line = null;
	 		while( (line = reader.readLine() )!= null )
	 		{
	 			Aluno aluno = extrairAluno ( line );
	 			
	 			System.out.println( aluno.toString() );
							
	 			for (i = 0; i < Bucket.NUM_SLOTS; i++ )
				{		
	//				Verifica se este slot est vazio.
					if ( !bucket.getSlot(i).ocupado() )
					{					
	//					Caso verdadeiro, armazena o aluno neste slot.
						bucket.getSlot(i).setAluno (aluno);
						break;
					}
				}
				
	//			Verifica se todos os slots foram preenchidos.
				if ( i == Bucket.NUM_SLOTS-1 ) 
				{				
	//				Caso verdadeiro, escreve este bucket no arquivo...
					bucket.write (raf);
	
	//				e limpa o contedo do bucket.
					for ( i = 0; i < Bucket.NUM_SLOTS; i++)
						bucket.getSlot(i).liberar ( );
				}
	 		}
		
	 		reader.close(); 
	     	streamReader.close(); 
	     	stream.close();
	     	raf.close();
	    }
		catch (FileNotFoundException e) {
         	//No caso do arquivo nao existir
         	System.out.println("Arquivo Inexistente");
         	System.exit(0);
		}
		catch (IOException e) {
         	System.out.println("Erro de leitura");
         	System.exit(0);
		}
		
		imprimir ("../AcessoDireto.dsk", "../EDIIA33.TXT");
    }
    
    //	A partir de um arquivo binrio, imprime na tela os alunos 
    //  identificados pelos pares (slot bucket), lidos de um arquivo texto.
	public static void imprimir (String _alunosFileName, String _printFileName)
	{
		System.out.println( "" );
		
		try {
			int nSlot = 0, nBucket = 0;
			Bucket bucket = new Bucket();
			
			FileInputStream stream = new FileInputStream(_printFileName);
			InputStreamReader streamReader = new InputStreamReader(stream);
			BufferedReader reader = new BufferedReader(streamReader);
			RandomAccessFile raf = new RandomAccessFile
			                           (new File(_alunosFileName), "rw");
				
			String line = null;
			
			System.out.println( "Slot Bucket Matricula"+ " " + "Nome" +
			  "             " + "Endereco" + "                  " + "Periodo");
			                    
	 		while( (line = reader.readLine() )!= null )
	 		{
 // divide o string de entrada em substrings cada vez que encontra o separador	 			
	 			String[] l = line.split(" ");
               	try {
                   nSlot = Integer.parseInt(l[0]); //  substring zero de l
                   nBucket = Integer.parseInt(l[1]); //  substring um de l
               	}
               	catch (NumberFormatException nfe) {
                   	System.out.println("Erro de leitura");
         			System.exit(0);
               	}
               	 
  //   calcula a posicao de nBucket, em bytes, em relacao ao inicio do arquivo              	              	
               	long pos = (nBucket-1) * Bucket.size();
 
  //   ajusta o ponteiro para o endereco desejado             	              	
               	raf.seek(pos);
  
  //   le para a instancia bucket             	
               	bucket.read (raf);
               	
				System.out.println( nSlot + " " + nBucket + "  " +
							bucket.getSlot(nSlot-1).getAluno().toString() );
	 		}
		
	 		reader.close(); 
	     	streamReader.close(); 
	     	stream.close();
	     	raf.close();
	    }
		catch (FileNotFoundException e) {
         	//No caso do arquivo nao existir
         	System.out.println("Arquivo Inexistente");
         	System.exit(0);
		}
		catch (IOException e) {
         	System.out.println("Erro de leitura");
         	System.exit(0);
		}
		
		System.out.println( "" );
	}

//	Cria um novo objeto da classe Aluno a partir de um string.
	public static Aluno extrairAluno (String _description)
	{
		Aluno aluno = new Aluno();
		
		int index = 0;
		
		aluno.setMatricula ( _description.substring
		                         ( index, Aluno.COMPRIMENTO_MAT ) );
			
		index += Aluno.COMPRIMENTO_MAT;
		
		aluno.setNome ( _description.substring
		                   ( index, index+Aluno.COMPRIMENTO_NOME ) );

		index += Aluno.COMPRIMENTO_NOME;

		aluno.setEndereco ( _description.substring
		                         ( index, index+Aluno.COMPRIMENTO_END ) );

		index += Aluno.COMPRIMENTO_END;

		aluno.setPeriodo ( Integer.parseInt( _description.substring
		                            ( index, index+1 ), 10 ) );
	
		return aluno;
	}
}
