import java.io.RandomAccessFile;
import java.io.IOException;


class Aluno {
	
	public Aluno()
	{
		mpr_matricula = MAT_INVALIDA;
		mpr_nome = "";
		mpr_endereco = "";
		mpr_periodo = 0;
	}
	
	public String getMatricula ()
	{
		return mpr_matricula;
	}

	public String getNome ()
	{
		return mpr_nome;
	}

	public String getEndereco ()
	{
		return mpr_endereco;
	}

	public int getPeriodo ()
	{
		return mpr_periodo;
	}

	public void setMatricula (String s)
	{
		mpr_matricula = s;
	}

	public void setNome (String s)
	{
		mpr_nome = s;
	}

	public void setEndereco (String s)
	{
		mpr_endereco = s;
	}

	public void setPeriodo (int n)
	{
		mpr_periodo = n;	
	}

	public String toString ()
	{
		return mpr_matricula + " " + mpr_nome + " " + mpr_endereco +
		                 " " + mpr_periodo;
	}
	
	public void write (RandomAccessFile arq)
	{
		byte[] stringData = new byte[MAX_CHARS]; 
        
        try { 
               
            for(int i = 0; i < COMPRIMENTO_MAT; i++) 
                stringData[i] = (byte)mpr_matricula.charAt(i); 
            arq.write(stringData); 
            
            for(int i = 0; i < COMPRIMENTO_NOME; i++) 
                stringData[i] = (byte)mpr_nome.charAt(i); 
            arq.write(stringData); 
            
            for(int i = 0; i < COMPRIMENTO_END; i++) 
                stringData[i] = (byte)mpr_endereco.charAt(i); 
            arq.write(stringData); 
            
            arq.writeInt(mpr_periodo);
        } 
        catch(IOException ex) { 
             System.out.println("Erro no salvamento do arquivo."); 
        } 
	}
	
	public void read (RandomAccessFile arq)
	{
		byte[] stringData = new byte[MAX_CHARS]; 
        
        try { 
            arq.read(stringData); 
            mpr_matricula = (new String(stringData)).
                              substring(0, COMPRIMENTO_MAT); 

			arq.read(stringData); 
            mpr_nome = (new String(stringData)); 
            
            arq.read(stringData); 
            mpr_endereco = (new String(stringData)); 
            
            mpr_periodo = arq.readInt();       
        
        } 
        catch(IOException ex) { 
             System.out.println("Erro na leitura do arquivo."); 
        } 
	}
	
	static public int size()
	{
		int ret = 0; 
        ret += 4; // tamanho de mpr_periodo
        ret += 3*MAX_CHARS; // Matrcula, nome e endereo.
        return(ret); 
	}
	
	public static final String MAT_INVALIDA = "ZZZZZZZ";
	public static final int MAX_CHARS = 32;
	public static final int COMPRIMENTO_MAT = 7;
	public static final int COMPRIMENTO_NOME = 32;
	public static final int COMPRIMENTO_END = 32;

	private String		mpr_matricula;
	private String		mpr_nome;
	private String		mpr_endereco;
	private int			mpr_periodo;
}
