import java.io.RandomAccessFile;
import java.io.IOException;

class Bucket {
	
	public Bucket( )
	{
		mpr_controle = 0;
		mpr_slots = new Slot [NUM_SLOTS];
		
		for (int i = 0; i < NUM_SLOTS; i++)
			mpr_slots[i] = new Slot();
	}
	
	public Slot getSlot( int n )
	{
		return mpr_slots[n];
	}

	public void write (RandomAccessFile in)
	{
		try { 
        	in.writeInt(mpr_controle);
        } 
        catch(IOException ex) { 
             System.out.println("Erro no salvamento do arquivo."); 
        }
        
        for (int i = 0; i < NUM_SLOTS; i++ )
        	mpr_slots[i].write (in);
	}
	
	public void read (RandomAccessFile in)
	{
		try { 
        	mpr_controle = in.readInt();
        } 
        catch(IOException ex) { 
             System.out.println("Erro na leitura do arquivo."); 
        }
        
        for (int i = 0; i < NUM_SLOTS; i++ )
        	mpr_slots[i].read (in);
	}
	
	static public int size()
	{
		int ret = 0; 
        ret += 4; // tamanho de mpr_controle
        ret += NUM_SLOTS * Slot.size(); // 
        return(ret); 
	
	}
	
	private int mpr_controle;
	private Slot [] mpr_slots;
	
	public static final int NUM_SLOTS = 3;
}
