import java.io.RandomAccessFile;
import java.io.IOException;

class Slot {
	
	public Slot( )
	{
		mpr_estado = Slot.NOVO;
		mpr_aluno = new Aluno( );
	}
	
	public boolean ocupado ()
	{
		return (mpr_estado == Slot.OCUPADO);
	}
	
	public void liberar ()
	{
		mpr_estado = Slot.VAZIO;
	}
	
	public Aluno getAluno()
	{
		return mpr_aluno;
	}
	
	public void setAluno(Aluno _aluno)
	{
		mpr_aluno = _aluno;
		mpr_estado = Slot.OCUPADO;
	}
	
	public void write (RandomAccessFile arq)
	{
		try { 
        	arq.writeInt(mpr_estado);
        } 
        catch(IOException ex) { 
             System.out.println("Erro no salvamento do arquivo."); 
        }
        
        mpr_aluno.write (arq);
	}
	
	public void read (RandomAccessFile arq)
	{
		try { 
        	mpr_estado = arq.readInt();
        } 
        catch(IOException ex) { 
             System.out.println("Erro na leitura do arquivo."); 
        }
        
        mpr_aluno.read (arq);
	}
	
	static public int size()
	{
		int ret = 0; 
        ret += 4; // tamanho de mpr_estado
        ret += Aluno.size(); // 
        return(ret); 
	
	}
	
	private int mpr_estado;
	private Aluno mpr_aluno;
	
	public static final int NOVO 	= 0;
	public static final int VAZIO 	= 1;
	public static final int OCUPADO = 2;
}
